searchNodes=[{"doc":"Generates a web router from an OpenAPI document. Building an OpenAPI-compliant Phoenix router can be as simple as: defmodule MyRouter do require Apical Apical . router_from_file ( &quot;path/to/openapi.yaml&quot; , controller : MyProjectWeb.ApiController ) end See https://spec.openapis.org/oas/v3.1.0 for details on how to compose an OpenAPI schema. Using the macros router_from_string/2 or router_from_file/2 you may generate a Phoenix.Router that corresponds to OpenAPI document. Tip In general, using router_from_file/2 is should be preferred, especially if you must maintain multiple versions of the schema, though you may find it easier to iterate using router_from_string/2 during early development. In that case, it is possible to switch to router_from_file/2 when you are ready to finalize your API design or start versioning Plug routers Plug -only routers, which do not require Phoenix , are planned for a future release. The following activities are performed by the router generated by the macros: Tagging inbound requests with API version Constructing route and http verb matches in the router Parameter operations Supports: Cookie parameters Header parameters Path parameters Query parameters Features: Style decoding based on parameter styles (see https://spec.openapis.org/oas/v3.1.0#style-values ) Custom style decoding Parameter marshalling (converting strings to types) Parameter validation Request body validation content-length and content-type validation matching content-type with request body plugs Automatic json and form-encoded request body parsing Parameter marshalling for form-encoded requests Options The following options are common to router_from_string/2 and router_from_file/2 . Global options encoding : mimetype which describes how the schema is encoded. required in router_from_string/2 , deduced from filename in router_from_file/2 . decoders : A proplist of mimetype to decoders. If you use an encoding that isn't application/json or application/yaml you should provide this proplist, which, at a minimum, contains [{encoding_mimetype, {module, function}}] . The call module.function(string) should return a map representing the OpenAPI schema, and should raise in the case that the content is not decodable. root : the root path for the router. Defaults to /v{major} where major is the major version of the API, as declared under info.version in the schema. dump : (For debugging), sends formatted code of the router to stdout. Defaults to false . If set to :all , will also pass dump: true to Exonerate. Scopable options The following options are scopable . They may be placed as top-level options or under the scopes (see below) controller : Plug module which contains code implementing the API. It is recommended to use Phoenix.Controller in this plug module, or the functions may or may not be targetted as expected. Controller modules should implement public functions corresponding to the operationId of each operation in the schema. These functions must be cased in the same fashion as the operationId , and like all Phoenix Controller functions, take two arguments: conn : the Plug.Conn for the request params : a map containing the parameters for the operation. This is identical to conn.params . Important Unlike standard Phoenix controller functions, parameters declared in the parameters list of the operation are made avaliable in the params argument as well as in conn.params . These parameters will overwrite any fields present in body parameters that happen to have the same name. A single router may have its routes target more than one controller. extra_plugs : a list of plugs to execute after the route has matched but before the parameter and body pipeline has been executed. These plugs are defined using {atom, [args...]} where args is a list of plug options to be applied to the plug, or atom which is equivalent to {atom, []} . These may be either a function plug or a module plug. Route-level Security Plugs Route-level security checks should be performed in plugs declared in extra_plugs , until Apical provides direct support for security schemes. Global plugs if you need plugs to be executed for all routes, declare those plugs in the router module before the macro Exonerate.router_from_* . Post-pipeline plugs if you need plugs to be executed after the parameter and body pipeline, for example, for row-level security checks, declare those plugs in the controller module. Note that these plugs should be able to match on the operationId atom using conn.private.operation_id . styles : a proplist of custom styles and their corresponding parsers. Each parser is represented as {module, function, [args...]} or {module, function} which is equivalent too {module, function []} . The parsers are functions that are called as module.function(string, args...) , and return {:ok, value} or {:error, message} . The message should be a string describing the error. The following styles are supported by default and do not need to be included in the styles proplist: &quot;matrix&quot; &quot;label&quot; &quot;simple&quot; &quot;form&quot; &quot;space_delimited&quot; &quot;pipe_delimited&quot; &quot;deep_object&quot; see https://spec.openapis.org/oas/v3.1.0#style-values for description of these styles. Custom styles If you need to support a custom style, you must add it to the styles proplist. Form-exploded objects Form-exploded style parameters with type object in their schema are not supported due to ambiguity in their definition per the OpenAPI specification. content_sources : A proplist of media-types (as string keys) and functions to act as the source for request body. These should be defined as {media_type, {module, [opts...]}} . These opts will be passed into the Apical.Plugs.RequestBody.Source.fetch/3 . nest_all_json : Analogous to the option in Plug.Parsers.JSON , this option will nest all json request body payloads under the &quot;_json&quot; key. if this is not true, objects payloads will be merged into conn.params . Available scopes The scopes have the following precedence: operation_ids &gt; tags &gt; parameters &gt; global operation_ids : A keywordlist of operationId s (as atom keys) and options to target to these operations. The keys must be cased in the same fashion as the operationId in the schema. tags : A keywordlist of tags (as atom keys) and options to target to those tags. The tag keys must be cased in the same fashion as their tags in the schema. parameters : A keywordlist of parameters (as atom keys) and options to target to those parameters. The parameter keys must be cased in the same fashion (including kebab-case) Note that this scope may be further nested inside of tag and operation_ids scopes.","ref":"Apical.html","title":"Apical","type":"module"},{"doc":"Generates a web router from a String containing an OpenAPI document. Example: defmodule MyRouter do require Apical Apical . router_from_file ( &quot;path/to/openapi.yaml&quot; , controller : MyProjectWeb.ApiController ) end For options see Apical module docs.","ref":"Apical.html#router_from_file/2","title":"Apical.router_from_file/2","type":"macro"},{"doc":"Generates a web router from a String containing an OpenAPI document. Example: defmodule MyRouter do require Apical Apical . router_from_string ( &quot;&quot;&quot; openapi: 3.1.0 info: title: My API version: 1.0.0 paths: &quot;/&quot;: get: operationId: getOperation responses: &quot;200&quot;: description: OK &quot;&quot;&quot; , controller : MyProjectWeb.ApiController , encoding : &quot;application/yaml&quot; ) end For options see Apical module docs.","ref":"Apical.html#router_from_string/2","title":"Apical.router_from_string/2","type":"macro"},{"doc":"Behaviour for adapters that process request bodies and alter the conn.","ref":"Apical.Plugs.RequestBody.Source.html","title":"Apical.Plugs.RequestBody.Source","type":"behaviour"},{"doc":"","ref":"Apical.Plugs.RequestBody.Source.html#c:fetch/3","title":"Apical.Plugs.RequestBody.Source.fetch/3","type":"callback"},{"doc":"Utility function that grabs request bodies. Apical.Plugs.RequestBody.Source modules are expected to use this function if they need the request body, since it conforms to the options keyword that plug uses natively. This function will exhaust the ability of the conn to have its body fetched. Thus, the use of this function is not required Streaming request bodies If the request body source plugin processes data in a streaming fashion, this function should not be used, instead manually call Plug.Conn.read_body/2 in your plugin's fetch/3 function options :length (integer, default 8_000_000 ) - total maximum length of the request body. :read_length (integer, default 1_000_000 ) - maximum length of each chunk. :string (boolean, default false ) - if true, the result will be a single binary, if false, the result may be an improper iolist.","ref":"Apical.Plugs.RequestBody.Source.html#fetch_body/2","title":"Apical.Plugs.RequestBody.Source.fetch_body/2","type":"function"},{"doc":"Compile-time check to see if the validator is valid for the given requestBody subschema. This may reject for any reason and should raise a CompileError if the validator cannot be used for that subschema.","ref":"Apical.Plugs.RequestBody.Source.html#c:validate!/2","title":"Apical.Plugs.RequestBody.Source.validate!/2","type":"callback"},{"doc":"Type for a function that encapsulates the logic for validating a request body. The function should return :ok if the body is valid, or {:error, keyword} In the generic case, keyword should contain the key :message which determines what the request body error message will be. For more specific cases, see the documentation for Exonerate which describes the fields available. The default validator (if no validation is to be performed) will return :ok on any input.","ref":"Apical.Plugs.RequestBody.Source.html#t:validator/0","title":"Apical.Plugs.RequestBody.Source.validator/0","type":"type"},{"doc":"Plug module for parsing cookie parameters and placing them into params. init options the plug initialization options are as follows: [router_module, operation_id, parameters, plug_opts] The router module is passed itself, the operation_id (as an atom), a list of parameters maps from the OpenAPI schema, one for each cookie parameter, and the plug_opts keyword list as elucidated by the router compiler. Initialization will compile an optimized operations object which is used to parse cookie parameters from the request. conn output The conn struct after calling this plug will have cookie parameters declared in the OpenAPI schema placed into the params map. Cookie parameters not declared in the OpenAPI schema are allowed.","ref":"Apical.Plugs.Cookie.html","title":"Apical.Plugs.Cookie","type":"module"},{"doc":"Plug module for parsing header parameters and placing them into params. init options the plug initialization options are as follows: [router_module, operation_id, parameters, plug_opts] The router module is passed itself, the operation_id (as an atom), a list of parameters maps from the OpenAPI schema, one for each cookie parameter, and the plug_opts keyword list as elucidated by the router compiler. Initialization will compile an optimized operations object which is used to parse header parameters from the request. conn output The conn struct after calling this plug will have header parameters declared in the OpenAPI schema placed into the params map. Header parameters not declared in the OpenAPI schema are allowed.","ref":"Apical.Plugs.Header.html","title":"Apical.Plugs.Header","type":"module"},{"doc":"Plug module for parsing path parameters and placing them into params. init options the plug initialization options are as follows: [router_module, operation_id, parameters, plug_opts] The router module is passed itself, the operation_id (as an atom), a list of parameters maps from the OpenAPI schema, one for each cookie parameter, and the plug_opts keyword list as elucidated by the router compiler. Initialization will compile an optimized operations object which is used to parse path parameters from the request. conn output The conn struct after calling this plug will have path parameters declared in the OpenAPI schema placed into the params map. Important As part of the OpenAPI spec, path parameters must be declared in the path key under the paths field of the schema.","ref":"Apical.Plugs.Path.html","title":"Apical.Plugs.Path","type":"module"},{"doc":"Plug module for parsing query parameters and placing them into params. init options the plug initialization options are as follows: [router_module, operation_id, parameters, plug_opts] The router module is passed itself, the operation_id (as an atom), a list of parameters maps from the OpenAPI schema, one for each cookie parameter, and the plug_opts keyword list as elucidated by the router compiler. Initialization will compile an optimized operations object which is used to parse query parameters from the request. conn output The conn struct after calling this plug will have query parameters declared in the OpenAPI schema placed into the params map. Important If the client produces a query parameter that is not a part of the OpenAPI schema, the request will fail with a 400 error.","ref":"Apical.Plugs.Query.html","title":"Apical.Plugs.Query","type":"module"},{"doc":"Plug module for parsing request bodies and placing them into params. init options There are several forms that the RequestBody plug may take. The following forms are recognized: [:match] Prepare the conn object for parsing the RequestBody plugs by obtaining the content-type and content-length header and setting private :content_type and :content_length keys, respectively. Raises appropriate errors early in the case that these headers are missing. [:not_matched] Rejects request bodies with a 415 error since the supplied content-type does not match any media-types declared in the OpenAPI schema. [router_module, operation_id, media_type_string, parameters, plug_opts] The router module is passed itself, the operation_id (as an atom), the media-type string for which the module applies, the requestBody map from the OpenAPI schema, and the plug_opts keyword list as elucidated by the router compiler. conn output for media-type plugs If the content-type header doesn't match the media-type string declared in the OpenApi schema, it is untouched. Note that if it fails to match it should be caught by a :not_matched variant of the plug downstream. Depending on the RequestBody source plugin supplied, the conn struct after calling this plug may have the request body placed into the params map. It may or may not also trigger reading the conn's request body. Note that fetching the request body may happen only once in the conn 's lifecycle. By default, the plugins are assigned to the media types as follows: application/json Apical.Plugs.RequestBody.Json application/x-www-form-urlencoded Apical.Plugs.RequestBody.FormEncoded */* Apical.Plugs.RequestBody.Default See documentation for the respective source plugins for more information.","ref":"Apical.Plugs.RequestBody.html","title":"Apical.Plugs.RequestBody","type":"module"},{"doc":"","ref":"Apical.Plugs.RequestBody.html#compare/2","title":"Apical.Plugs.RequestBody.compare/2","type":"function"},{"doc":"","ref":"Apical.Plugs.RequestBody.html#make/4","title":"Apical.Plugs.RequestBody.make/4","type":"function"},{"doc":"","ref":"Apical.Plugs.RequestBody.html#validator_name/3","title":"Apical.Plugs.RequestBody.validator_name/3","type":"function"},{"doc":"Plug module which sets the private :operation_id key on the conn struct to the operationId (as an atom) that was declared in the schema.","ref":"Apical.Plugs.SetOperationId.html","title":"Apical.Plugs.SetOperationId","type":"module"},{"doc":"Plug module which sets the :api_version key on the conn struct's assigns to the version string that was declared in the schema.","ref":"Apical.Plugs.SetVersion.html","title":"Apical.Plugs.SetVersion","type":"module"},{"doc":"","ref":"Apical.Plugs.RequestBody.Default.html","title":"Apical.Plugs.RequestBody.Default","type":"module"},{"doc":"","ref":"Apical.Plugs.RequestBody.FormEncoded.html","title":"Apical.Plugs.RequestBody.FormEncoded","type":"module"},{"doc":"","ref":"Apical.Plugs.RequestBody.Json.html","title":"Apical.Plugs.RequestBody.Json","type":"module"},{"doc":"Error raised when the content-length header does not parse to a valid integer. This error should result in a http 411 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/411","ref":"Apical.Exceptions.InvalidContentLengthError.html","title":"Apical.Exceptions.InvalidContentLengthError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.InvalidContentLengthError.html#message/1","title":"Apical.Exceptions.InvalidContentLengthError.message/1","type":"function"},{"doc":"Error raised when the content-type header does not parse to a valid mimetype string. This error should result in a http 400 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/400","ref":"Apical.Exceptions.InvalidContentTypeError.html","title":"Apical.Exceptions.InvalidContentTypeError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.InvalidContentTypeError.html#message/1","title":"Apical.Exceptions.InvalidContentTypeError.message/1","type":"function"},{"doc":"Error raised when the content-length header is missing from the request. This error should result in a http 411 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/411","ref":"Apical.Exceptions.MissingContentLengthError.html","title":"Apical.Exceptions.MissingContentLengthError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.MissingContentLengthError.html#message/1","title":"Apical.Exceptions.MissingContentLengthError.message/1","type":"function"},{"doc":"Error raised when the content-type header is missing from the request. This error should result in a http 400 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/400","ref":"Apical.Exceptions.MissingContentTypeError.html","title":"Apical.Exceptions.MissingContentTypeError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.MissingContentTypeError.html#message/1","title":"Apical.Exceptions.MissingContentTypeError.message/1","type":"function"},{"doc":"Error raised multiple content-length headers are provided by the request. This error should result in a http 411 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/411","ref":"Apical.Exceptions.MultipleContentLengthError.html","title":"Apical.Exceptions.MultipleContentLengthError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.MultipleContentLengthError.html#message/1","title":"Apical.Exceptions.MultipleContentLengthError.message/1","type":"function"},{"doc":"Error raised multiple content-type headers are provided by the request. This error should result in a http 400 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/400","ref":"Apical.Exceptions.MultipleContentTypeError.html","title":"Apical.Exceptions.MultipleContentTypeError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.MultipleContentTypeError.html#message/1","title":"Apical.Exceptions.MultipleContentTypeError.message/1","type":"function"},{"doc":"Error raised when parameters are invalid. Note that many of the fields correspond to error parameters returned by Exonerate validators. This error should result in a http 400 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/400","ref":"Apical.Exceptions.ParameterError.html","title":"Apical.Exceptions.ParameterError","type":"exception"},{"doc":"","ref":"Apical.Exceptions.ParameterError.html#custom_fields_from/5","title":"Apical.Exceptions.ParameterError.custom_fields_from/5","type":"function"},{"doc":"","ref":"Apical.Exceptions.ParameterError.html#describe_exonerate/1","title":"Apical.Exceptions.ParameterError.describe_exonerate/1","type":"function"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.ParameterError.html#message/1","title":"Apical.Exceptions.ParameterError.message/1","type":"function"},{"doc":"Error raised when the request body is too large. This could be because the payload is larger than the maximum allowed size as specified in configuration or if the request body size doesn't match the content-length header. This error should result in a http 413 status code. see: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/413","ref":"Apical.Exceptions.RequestBodyTooLargeError.html","title":"Apical.Exceptions.RequestBodyTooLargeError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Apical.Exceptions.RequestBodyTooLargeError.html#message/1","title":"Apical.Exceptions.RequestBodyTooLargeError.message/1","type":"function"}]